function [TimeRL,accRL,tempRL,ErrRadialLink] = defDatiRL(DatiRadialLink,...
    ErrRadialLink,Ndatidespike,rRL,MEMS,FileName)

fileID = fopen(FileName,'a');
fmt = '%s \r';
text = 'defDatiRL function started';
fprintf(fileID,fmt,text);

[r,c] = size(DatiRadialLink);
Ncorr = 0;
% Elimino gli eventuali Not a Number
for a = 2:r
    for b = 2:c
        check = isnan(DatiRadialLink(a,b));
        if check == 1
            DatiRadialLink(a,b) = DatiRadialLink(a-1,b);
            ErrRadialLink(a,b-1) = 1;
            Ncorr = Ncorr+1;
        end
    end
end

text = ['' num2str(Ncorr) ' NaN of Radial Link corrected by defDatiRL function'];
fprintf(fileID,fmt,text);

% Definisco Data (gg:mm:aaaa hh:mm), Batteria, i 3 dati di accelerometro
% e magnetometro e la Temperatura per la calibrazione
TimeRL = DatiRadialLink(:,1); % data
accRL = zeros(r,rRL*3); % dati accelerometro
tempRL = zeros(r,rRL); % temperatura del nodo per la calibrazione
p = 4; % passo nella definizione dei dati
s = 1;

for i = 1:rRL
    accRL(:,s) = DatiRadialLink(:,2+(i-1)*p);
    accRL(:,s+1) = DatiRadialLink(:,3+(i-1)*p);
    accRL(:,s+2) = DatiRadialLink(:,4+(i-1)*p);    
    s = s+3;
    tempRL(:,i) = DatiRadialLink(:,5+(i-1)*p);
    [rT,~] = size(tempRL);
    if MEMS == 2
        for j = 1:rT
            if tempRL(j,i) > 200
                tempRL(j,i) = tempRL(j,i) - 256; % Correzione della temperatura dei nuovi MEMS
            end
        end
    end
end

s = 1;
Num_Dati = Ndatidespike; % numero di dati per il despike
if Num_Dati > r
    Num_Dati = r;
end
for i = 1:rRL
    % despiking accelerometri
    accRL(:,s) = filloutliers(accRL(:,s),'linear','movmedian',Num_Dati);
    accRL(:,s+1) = filloutliers(accRL(:,s+1),'linear','movmedian',Num_Dati);
    accRL(:,s+2) = filloutliers(accRL(:,s+2),'linear','movmedian',Num_Dati);
    s = s+3;
end

text = 'Data of Radial Link defined correctly. defDatiRL function closed';
fprintf(fileID,fmt,text);
fclose(fileID);
end